// ------------------------------------------------ ------------------
// | Lukas1 arrows & curves.mq4 v.14 |
// | Changes: |
// | 1. Removed unnecessary (unnecessary) coefficients which are not signatories |
// | In the calculation of Kmin, Kmax, RISK |
// | 2. Mathematics indicator performs all calculations |
// | In one cycle, it increased the speed of data reduction. |
// | 3. Off blinking arrows. |
// ------------------------------------------------ ------------------

#property copyright "Copyright  2007, lukas1"
#property link      "http://www.alpari-idc.ru/"
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Green
//---- input parameters
extern int SSP       = 6;     // period lineynogo razvorota indicator
extern int CountBars = 2250;  // settlement period
extern int SkyCh     = 13;    //sensitivity to the breakdown channel
// Should be in the range of 0-50. 0 - no arrows. More than 50 - overshoot
int    i;
double high, low, smin, smax;
double val1[];      // buffer to buy
double val2[];      // buffer to Sell
double Sky_BufferH[];
double Sky_BufferL[];
bool   uptrend, old;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);        // Arrow to buy
   SetIndexBuffer(0, val1);      // index buffer to buy
   SetIndexDrawBegin(0, 2*SSP);
   //
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);        // Arrow to Sell
   SetIndexBuffer(1, val2);      // index buffer to Sell
   SetIndexDrawBegin(1, 2*SSP);
   //
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, Sky_BufferH);
   SetIndexLabel(2, "High");
   SetIndexDrawBegin(2, 2*SSP);
   //
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, Sky_BufferL);
   SetIndexLabel(3, "Low");
   SetIndexDrawBegin(3, 2*SSP);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Calculation of SilverTrend lines                                 | 
//+------------------------------------------------------------------+
int start()
  {   
   int counted_bars = IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars > 0) counted_bars--;
//----
   if(Bars <= SSP + 1)        return(0);
//---- initial zero
   uptrend       =false;
   old           =false;
   GlobalVariableSet("goSELL", 0); // posed the existence and zero goSELL = 0
   GlobalVariableSet("goBUY", 0);  // posed the existence and zero goBUY = 0
//----
   for(i = CountBars - SSP; i >= 0; i--) // decreasing the shift of 1 per pass
     { 
       high = High[iHighest(Symbol(),0,MODE_HIGH,SSP,i)]; 
       low = Low[iLowest(Symbol(),0,MODE_LOW,SSP,i)]; 
       smax = high - (high - low)*SkyCh / 100; // smax below the high, taking into account koeff.SkyCh
       smin = low + (high - low)*SkyCh / 100;  // smin above low given koeff.SkyCh
	    val1[i] = 0;  
       val2[i] = 0;
       if(Close[i] < smin && i!=0 )	// off blinking arrows (i! = 0)
       {
       uptrend = false;
       }
	    if(Close[i] > smax && i!=0 )	// off blinking arrows (i! = 0)	
	    {
	    uptrend = true;       
       }       
       if(uptrend != old && uptrend == false)
         {
           val2[i] = high; // if the conditions are fulfilled then draw val1
           if(i == 0)                GlobalVariableSet("goBUY",1);
         }
       if(uptrend != old && uptrend == true ) 
         {
           val1[i] = low; // if the conditions are fulfilled then draw val2
           if(i == 0)                GlobalVariableSet("goSELL",1);
         }
       old=uptrend;
       Sky_BufferH[i]=high - (high - low)*SkyCh / 100;
       Sky_BufferL[i]=low +  (high - low)*SkyCh / 100;
     }
   return(0);
  }
//+------------------------------------------------------------------+